// Code generated by protoc-gen-go.
// source: google.golang.org/genproto/googleapis/api/serviceconfig/service.proto
// DO NOT EDIT!

package google_api // import "google.golang.org/genproto/googleapis/api/serviceconfig"

import proto "github.com/golang/protobuf/proto"
import fmt "fmt"
import math "math"
import _ "google.golang.org/genproto/googleapis/api/label"
import google_api2 "google.golang.org/genproto/googleapis/api/metric"
import google_api3 "google.golang.org/genproto/googleapis/api/monitoredres"
import _ "github.com/golang/protobuf/ptypes/any"
import google_protobuf4 "google.golang.org/genproto/protobuf"
import google_protobuf3 "google.golang.org/genproto/protobuf"
import google_protobuf5 "github.com/golang/protobuf/ptypes/wrappers"

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// `Service` is the root object of the configuration schema. It
// describes basic information like the name of the service and the
// exposed API interfaces, and delegates other aspects to configuration
// sub-sections.
//
// Example:
//
//     type: google.api.Service
//     config_version: 1
//     name: calendar.googleapis.com
//     title: Google Calendar API
//     apis:
//     - name: google.calendar.Calendar
//     backend:
//       rules:
//       - selector: "*"
//         address: calendar.example.com
type Service struct {
	// The version of the service configuration. The config version may
	// influence interpretation of the configuration, for example, to
	// determine defaults. This is documented together with applicable
	// options. The current default for the config version itself is `3`.
	ConfigVersion *google_protobuf5.UInt32Value `protobuf:"bytes,20,opt,name=config_version,json=configVersion" json:"config_version,omitempty"`
	// The DNS address at which this service is available,
	// e.g. `calendar.googleapis.com`.
	Name string `protobuf:"bytes,1,opt,name=name" json:"name,omitempty"`
	// A unique ID for a specific instance of this message, typically assigned
	// by the client for tracking purpose. If empty, the server may choose to
	// generate one instead.
	Id string `protobuf:"bytes,33,opt,name=id" json:"id,omitempty"`
	// The product title associated with this service.
	Title string `protobuf:"bytes,2,opt,name=title" json:"title,omitempty"`
	// The id of the Google developer project that owns the service.
	// Members of this project can manage the service configuration,
	// manage consumption of the service, etc.
	ProducerProjectId string `protobuf:"bytes,22,opt,name=producer_project_id,json=producerProjectId" json:"producer_project_id,omitempty"`
	// A list of API interfaces exported by this service. Only the `name` field
	// of the [google.protobuf.Api][google.protobuf.Api] needs to be provided by the configuration
	// author, as the remaining fields will be derived from the IDL during the
	// normalization process. It is an error to specify an API interface here
	// which cannot be resolved against the associated IDL files.
	Apis []*google_protobuf4.Api `protobuf:"bytes,3,rep,name=apis" json:"apis,omitempty"`
	// A list of all proto message types included in this API service.
	// Types referenced directly or indirectly by the `apis` are
	// automatically included.  Messages which are not referenced but
	// shall be included, such as types used by the `google.protobuf.Any` type,
	// should be listed here by name. Example:
	//
	//     types:
	//     - name: google.protobuf.Int32
	Types []*google_protobuf3.Type `protobuf:"bytes,4,rep,name=types" json:"types,omitempty"`
	// A list of all enum types included in this API service.  Enums
	// referenced directly or indirectly by the `apis` are automatically
	// included.  Enums which are not referenced but shall be included
	// should be listed here by name. Example:
	//
	//     enums:
	//     - name: google.someapi.v1.SomeEnum
	Enums []*google_protobuf3.Enum `protobuf:"bytes,5,rep,name=enums" json:"enums,omitempty"`
	// Additional API documentation.
	Documentation *Documentation `protobuf:"bytes,6,opt,name=documentation" json:"documentation,omitempty"`
	// API backend configuration.
	Backend *Backend `protobuf:"bytes,8,opt,name=backend" json:"backend,omitempty"`
	// HTTP configuration.
	Http *Http `protobuf:"bytes,9,opt,name=http" json:"http,omitempty"`
	// Auth configuration.
	Authentication *Authentication `protobuf:"bytes,11,opt,name=authentication" json:"authentication,omitempty"`
	// Context configuration.
	Context *Context `protobuf:"bytes,12,opt,name=context" json:"context,omitempty"`
	// Configuration controlling usage of this service.
	Usage *Usage `protobuf:"bytes,15,opt,name=usage" json:"usage,omitempty"`
	// Configuration of per-consumer project properties.
	ProjectProperties *ProjectProperties `protobuf:"bytes,17,opt,name=project_properties,json=projectProperties" json:"project_properties,omitempty"`
	// Configuration for the service control plane.
	Control *Control `protobuf:"bytes,21,opt,name=control" json:"control,omitempty"`
	// Defines the logs used by this service.
	Logs []*LogDescriptor `protobuf:"bytes,23,rep,name=logs" json:"logs,omitempty"`
	// Defines the metrics used by this service.
	Metrics []*google_api2.MetricDescriptor `protobuf:"bytes,24,rep,name=metrics" json:"metrics,omitempty"`
	// Defines the monitored resources used by this service. This is required
	// by the [Service.monitoring][google.api.Service.monitoring] and [Service.logging][google.api.Service.logging] configurations.
	//
	MonitoredResources []*google_api3.MonitoredResourceDescriptor `protobuf:"bytes,25,rep,name=monitored_resources,json=monitoredResources" json:"monitored_resources,omitempty"`
	// Billing configuration of the service.
	Billing *Billing `protobuf:"bytes,26,opt,name=billing" json:"billing,omitempty"`
	// Logging configuration of the service.
	Logging *Logging `protobuf:"bytes,27,opt,name=logging" json:"logging,omitempty"`
	// Monitoring configuration of the service.
	Monitoring *Monitoring `protobuf:"bytes,28,opt,name=monitoring" json:"monitoring,omitempty"`
	// Configuration for system parameters.
	SystemParameters *SystemParameters `protobuf:"bytes,29,opt,name=system_parameters,json=systemParameters" json:"system_parameters,omitempty"`
}

func (m *Service) Reset()                    { *m = Service{} }
func (m *Service) String() string            { return proto.CompactTextString(m) }
func (*Service) ProtoMessage()               {}
func (*Service) Descriptor() ([]byte, []int) { return fileDescriptor12, []int{0} }

func (m *Service) GetConfigVersion() *google_protobuf5.UInt32Value {
	if m != nil {
		return m.ConfigVersion
	}
	return nil
}

func (m *Service) GetApis() []*google_protobuf4.Api {
	if m != nil {
		return m.Apis
	}
	return nil
}

func (m *Service) GetTypes() []*google_protobuf3.Type {
	if m != nil {
		return m.Types
	}
	return nil
}

func (m *Service) GetEnums() []*google_protobuf3.Enum {
	if m != nil {
		return m.Enums
	}
	return nil
}

func (m *Service) GetDocumentation() *Documentation {
	if m != nil {
		return m.Documentation
	}
	return nil
}

func (m *Service) GetBackend() *Backend {
	if m != nil {
		return m.Backend
	}
	return nil
}

func (m *Service) GetHttp() *Http {
	if m != nil {
		return m.Http
	}
	return nil
}

func (m *Service) GetAuthentication() *Authentication {
	if m != nil {
		return m.Authentication
	}
	return nil
}

func (m *Service) GetContext() *Context {
	if m != nil {
		return m.Context
	}
	return nil
}

func (m *Service) GetUsage() *Usage {
	if m != nil {
		return m.Usage
	}
	return nil
}

func (m *Service) GetProjectProperties() *ProjectProperties {
	if m != nil {
		return m.ProjectProperties
	}
	return nil
}

func (m *Service) GetControl() *Control {
	if m != nil {
		return m.Control
	}
	return nil
}

func (m *Service) GetLogs() []*LogDescriptor {
	if m != nil {
		return m.Logs
	}
	return nil
}

func (m *Service) GetMetrics() []*google_api2.MetricDescriptor {
	if m != nil {
		return m.Metrics
	}
	return nil
}

func (m *Service) GetMonitoredResources() []*google_api3.MonitoredResourceDescriptor {
	if m != nil {
		return m.MonitoredResources
	}
	return nil
}

func (m *Service) GetBilling() *Billing {
	if m != nil {
		return m.Billing
	}
	return nil
}

func (m *Service) GetLogging() *Logging {
	if m != nil {
		return m.Logging
	}
	return nil
}

func (m *Service) GetMonitoring() *Monitoring {
	if m != nil {
		return m.Monitoring
	}
	return nil
}

func (m *Service) GetSystemParameters() *SystemParameters {
	if m != nil {
		return m.SystemParameters
	}
	return nil
}

func init() {
	proto.RegisterType((*Service)(nil), "google.api.Service")
}

func init() {
	proto.RegisterFile("google.golang.org/genproto/googleapis/api/serviceconfig/service.proto", fileDescriptor12)
}

var fileDescriptor12 = []byte{
	// 799 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x09, 0x6e, 0x88, 0x02, 0xff, 0xac, 0x96, 0x6f, 0x4f, 0xeb, 0x36,
	0x14, 0xc6, 0x55, 0x6e, 0x7b, 0x19, 0xe6, 0xc2, 0xa8, 0xf9, 0x33, 0xd3, 0x81, 0xd4, 0x4d, 0x93,
	0xa8, 0x34, 0x91, 0x48, 0x20, 0x21, 0x4d, 0xd3, 0x34, 0x51, 0x60, 0xa2, 0x1a, 0xdb, 0x2a, 0x33,
	0xd0, 0xde, 0x55, 0x6e, 0x62, 0x82, 0xb7, 0xc4, 0xb6, 0x6c, 0x87, 0xad, 0x1f, 0x62, 0xdf, 0x79,
	0x8a, 0xed, 0xb4, 0x69, 0xcb, 0x36, 0x96, 0xee, 0x05, 0x90, 0xf8, 0xfc, 0x9e, 0x27, 0xe7, 0xe4,
	0xc4, 0xc7, 0x80, 0x9b, 0x44, 0x88, 0x24, 0xa5, 0x41, 0x22, 0x52, 0xc2, 0x93, 0x40, 0xa8, 0x24,
	0x4c, 0x28, 0x97, 0x4a, 0x18, 0x11, 0xba, 0x10, 0x91, 0x4c, 0x87, 0x44, 0xb2, 0x50, 0x53, 0xf5,
	0xc2, 0x22, 0x1a, 0x09, 0xfe, 0xc4, 0x92, 0xf2, 0x2e, 0xb0, 0x28, 0x04, 0xde, 0x86, 0x48, 0xd6,
	0x19, 0xd4, 0xb5, 0x24, 0x9c, 0x0b, 0x43, 0x0c, 0x13, 0x5c, 0x3b, 0xdb, 0x4e, 0xbf, 0xb6, 0x55,
	0x6e, 0x9e, 0xbd, 0x47, 0xed, 0x0a, 0xc7, 0x24, 0xfa, 0x8d, 0xf2, 0x78, 0x65, 0x1b, 0x96, 0xa6,
	0x8c, 0x27, 0xde, 0xe6, 0xbb, 0xba, 0x36, 0x91, 0xe0, 0x3a, 0xcf, 0xa8, 0x5a, 0x35, 0x9d, 0x48,
	0x70, 0x43, 0xff, 0x30, 0xff, 0x87, 0x8d, 0x12, 0xa9, 0xb7, 0xf9, 0xbe, 0xae, 0x4d, 0x2c, 0xa2,
	0x3c, 0xa3, 0xdc, 0x75, 0x7d, 0xd5, 0xa6, 0x3f, 0x1b, 0x23, 0xbd, 0xc7, 0xd7, 0x6f, 0xf7, 0x48,
	0xc9, 0x98, 0xa6, 0xee, 0xb7, 0x17, 0x5f, 0xd6, 0x4d, 0x20, 0x15, 0xc9, 0xaa, 0xef, 0x35, 0x15,
	0x49, 0x32, 0xfb, 0x5a, 0xbe, 0x79, 0xbb, 0x4d, 0x46, 0x8d, 0x62, 0x91, 0xff, 0xe3, 0xe5, 0x3f,
	0xfd, 0x07, 0xb9, 0xe0, 0xcc, 0x08, 0x45, 0x63, 0x45, 0xf5, 0xec, 0x66, 0xa4, 0xa8, 0x16, 0xb9,
	0x2a, 0xb7, 0x79, 0xe7, 0xb6, 0x6e, 0x59, 0xde, 0x71, 0x56, 0xd9, 0x8f, 0xb5, 0xe7, 0xce, 0x44,
	0x1b, 0x9a, 0x8d, 0x24, 0x51, 0x24, 0xa3, 0x66, 0xba, 0x1f, 0xae, 0xea, 0xfa, 0xe5, 0x9a, 0x24,
	0x65, 0x79, 0x61, 0xc2, 0xcc, 0x73, 0x3e, 0x0e, 0x22, 0x91, 0x85, 0xce, 0x28, 0xb4, 0x81, 0x71,
	0xfe, 0x14, 0x4a, 0x33, 0x91, 0x54, 0x87, 0x84, 0x4f, 0x8a, 0x1f, 0x2f, 0x38, 0xfd, 0x87, 0xa7,
	0x4e, 0x95, 0x44, 0x32, 0x8f, 0x07, 0x6f, 0xc1, 0x8b, 0xe7, 0x78, 0xfe, 0xab, 0x7f, 0xcf, 0xe7,
	0x77, 0x45, 0xa4, 0xa4, 0x6a, 0x76, 0xe1, 0xa4, 0x9f, 0xff, 0xb9, 0x01, 0xd6, 0xef, 0x5d, 0xa1,
	0xf0, 0x0a, 0x6c, 0xbb, 0x62, 0x47, 0x2f, 0x54, 0x69, 0x26, 0x38, 0xda, 0xeb, 0x36, 0x7a, 0x9b,
	0x67, 0x47, 0x65, 0x3e, 0xa5, 0x69, 0xf0, 0x30, 0xe0, 0xe6, 0xfc, 0xec, 0x91, 0xa4, 0x39, 0xc5,
	0x5b, 0x4e, 0xf3, 0xe8, 0x24, 0x10, 0x82, 0x26, 0x27, 0x19, 0x45, 0x8d, 0x6e, 0xa3, 0xb7, 0x81,
	0xed, 0x35, 0xdc, 0x06, 0x6b, 0x2c, 0x46, 0x9f, 0xd9, 0x95, 0x35, 0x16, 0xc3, 0x3d, 0xd0, 0x32,
	0xcc, 0xa4, 0x14, 0xad, 0xd9, 0x25, 0x77, 0x03, 0x03, 0xb0, 0x2b, 0x95, 0x88, 0xf3, 0x88, 0xaa,
	0x91, 0x54, 0xe2, 0x57, 0x1a, 0x99, 0x11, 0x8b, 0xd1, 0x81, 0x65, 0xda, 0x65, 0x68, 0xe8, 0x22,
	0x83, 0x18, 0xf6, 0x40, 0xb3, 0xe8, 0x15, 0x7a, 0xd7, 0x7d, 0xd7, 0xdb, 0x3c, 0xdb, 0x5b, 0x4a,
	0xf2, 0x52, 0x32, 0x6c, 0x09, 0xf8, 0x25, 0x68, 0xd9, 0xb7, 0x80, 0x9a, 0x16, 0xdd, 0x5f, 0x42,
	0x7f, 0x9e, 0x48, 0x8a, 0x1d, 0x53, 0xc0, 0x94, 0xe7, 0x99, 0x46, 0xad, 0xbf, 0x81, 0x6f, 0x78,
	0x9e, 0x61, 0xc7, 0xc0, 0x6f, 0xc1, 0xd6, 0xdc, 0x68, 0x42, 0xef, 0xed, 0x1b, 0x3b, 0x0c, 0x66,
	0xe7, 0x5c, 0x70, 0x5d, 0x05, 0xf0, 0x3c, 0x0f, 0x4f, 0xc1, 0xba, 0x3f, 0x3f, 0xd0, 0x47, 0x56,
	0xba, 0x5b, 0x95, 0xf6, 0x5d, 0x08, 0x97, 0x0c, 0xfc, 0x02, 0x34, 0x8b, 0xe9, 0x85, 0x36, 0x2c,
	0xbb, 0x53, 0x65, 0x6f, 0x8d, 0x91, 0xd8, 0x46, 0x61, 0x1f, 0x6c, 0x17, 0x07, 0x1b, 0xe5, 0x86,
	0x45, 0x2e, 0xad, 0x4d, 0xcb, 0x77, 0xaa, 0xfc, 0xe5, 0x1c, 0x81, 0x17, 0x14, 0x45, 0x62, 0xfe,
	0x08, 0x40, 0x1f, 0x96, 0x13, 0xbb, 0x72, 0x21, 0x5c, 0x32, 0xf0, 0x04, 0xb4, 0xec, 0x0e, 0x41,
	0x1f, 0x5b, 0xb8, 0x5d, 0x85, 0x1f, 0x8a, 0x00, 0x76, 0x71, 0x78, 0x07, 0x60, 0xd9, 0x5c, 0xa9,
	0x84, 0xa4, 0xca, 0x30, 0xaa, 0x51, 0xdb, 0xaa, 0x8e, 0xab, 0x2a, 0xdf, 0xe8, 0xe1, 0x14, 0xb2,
	0xdf, 0xc0, 0xfc, 0x52, 0x99, 0xa5, 0x12, 0x29, 0xda, 0x7f, 0x3d, 0x4b, 0x25, 0x52, 0x5c, 0x32,
	0xf0, 0x14, 0x34, 0x53, 0x91, 0x68, 0xf4, 0x89, 0x6d, 0xed, 0x5c, 0x97, 0xee, 0x44, 0x72, 0x4d,
	0x75, 0xa4, 0x98, 0x34, 0x42, 0x61, 0x8b, 0xc1, 0x0b, 0xb0, 0xee, 0xe6, 0xa4, 0x46, 0xc8, 0x2a,
	0x8e, 0xaa, 0x8a, 0x1f, 0x6c, 0xa8, 0x22, 0x2a, 0x61, 0xf8, 0x0b, 0xd8, 0x5d, 0x1e, 0x8d, 0x1a,
	0x1d, 0x5a, 0x8f, 0x93, 0x39, 0x8f, 0x12, 0xc3, 0x9e, 0xaa, 0xd8, 0xc1, 0x6c, 0x31, 0x68, 0xeb,
	0xf5, 0xff, 0x27, 0xa0, 0xce, 0x2b, 0x9f, 0x8b, 0x0b, 0xe1, 0x92, 0x29, 0x70, 0x7f, 0x50, 0xa0,
	0x4f, 0x97, 0xf1, 0x3b, 0x17, 0xc2, 0x25, 0x03, 0x2f, 0x00, 0x98, 0x0d, 0x60, 0x74, 0x64, 0x15,
	0x07, 0xaf, 0xa4, 0x5b, 0x88, 0x2a, 0x24, 0x1c, 0x80, 0xf6, 0xe2, 0xb8, 0xd5, 0xe8, 0x78, 0x7e,
	0x76, 0x14, 0xf2, 0x7b, 0x0b, 0x0d, 0xa7, 0x0c, 0xde, 0xd1, 0x0b, 0x2b, 0xfd, 0x6e, 0x31, 0x83,
	0xb2, 0x8a, 0xa8, 0xff, 0xc1, 0x8f, 0xa7, 0x61, 0xb1, 0xff, 0x86, 0x8d, 0xf1, 0x7b, 0xbb, 0x11,
	0xcf, 0xff, 0x0a, 0x00, 0x00, 0xff, 0xff, 0x14, 0xa3, 0xaf, 0xd9, 0x92, 0x0a, 0x00, 0x00,
}
