// Code generated by protoc-gen-go.
// source: google.golang.org/genproto/googleapis/api/serviceconfig/usage.proto
// DO NOT EDIT!

package google_api // import "google.golang.org/genproto/googleapis/api/serviceconfig"

import proto "github.com/golang/protobuf/proto"
import fmt "fmt"
import math "math"

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// Service access types.
//
// Access to restricted API features is always controlled by
// [visibility][google.api.Visibility], independent of the ServiceAccess type.
//
type Usage_ServiceAccess int32

const (
	// The service can only be seen/used by users identified in the service's
	// access control policy.
	//
	// If the service has not been whitelisted by your domain administrator
	// for out-of-org publishing, then this mode will be treated like
	// ORG_RESTRICTED.
	Usage_RESTRICTED Usage_ServiceAccess = 0
	// The service can be seen/used by anyone.
	//
	// If the service has not been whitelisted by your domain administrator
	// for out-of-org publishing, then this mode will be treated like
	// ORG_PUBLIC.
	//
	// The discovery document for the service will also be public and allow
	// unregistered access.
	Usage_PUBLIC Usage_ServiceAccess = 1
	// The service can be seen/used by users identified in the service's
	// access control policy and they are within the organization that owns the
	// service.
	//
	// Access is further constrained to the group
	// controlled by the administrator of the project/org that owns the
	// service.
	Usage_ORG_RESTRICTED Usage_ServiceAccess = 2
	// The service can be seen/used by the group of users controlled by the
	// administrator of the project/org that owns the service.
	Usage_ORG_PUBLIC Usage_ServiceAccess = 3
)

var Usage_ServiceAccess_name = map[int32]string{
	0: "RESTRICTED",
	1: "PUBLIC",
	2: "ORG_RESTRICTED",
	3: "ORG_PUBLIC",
}
var Usage_ServiceAccess_value = map[string]int32{
	"RESTRICTED":     0,
	"PUBLIC":         1,
	"ORG_RESTRICTED": 2,
	"ORG_PUBLIC":     3,
}

func (x Usage_ServiceAccess) String() string {
	return proto.EnumName(Usage_ServiceAccess_name, int32(x))
}
func (Usage_ServiceAccess) EnumDescriptor() ([]byte, []int) { return fileDescriptor14, []int{0, 0} }

// Configuration controlling usage of a service.
type Usage struct {
	// Controls which users can see or activate the service.
	ServiceAccess Usage_ServiceAccess `protobuf:"varint,4,opt,name=service_access,json=serviceAccess,enum=google.api.Usage_ServiceAccess" json:"service_access,omitempty"`
	// Requirements that must be satisfied before a consumer project can use the
	// service. Each requirement is of the form <service.name>/<requirement-id>;
	// for example 'serviceusage.googleapis.com/billing-enabled'.
	Requirements []string `protobuf:"bytes,1,rep,name=requirements" json:"requirements,omitempty"`
	// Services that must be activated in order for this service to be used.
	// The set of services activated as a result of these relations are all
	// activated in parallel with no guaranteed order of activation.
	// Each string is a service name, e.g. `calendar.googleapis.com`.
	DependsOnServices []string `protobuf:"bytes,2,rep,name=depends_on_services,json=dependsOnServices" json:"depends_on_services,omitempty"`
	// Services that must be contacted before a consumer can begin using the
	// service. Each service will be contacted in sequence, and, if any activation
	// call fails, the entire activation will fail. Each hook is of the form
	// <service.name>/<hook-id>, where <hook-id> is optional; for example:
	// 'robotservice.googleapis.com/default'.
	ActivationHooks []string `protobuf:"bytes,3,rep,name=activation_hooks,json=activationHooks" json:"activation_hooks,omitempty"`
	// Services that must be contacted before a consumer can deactivate a
	// service. Each service will be contacted in sequence, and, if any
	// deactivation call fails, the entire deactivation will fail. Each hook is
	// of the form <service.name>/<hook-id>, where <hook-id> is optional; for
	// example:
	// 'compute.googleapis.com/'.
	DeactivationHooks []string `protobuf:"bytes,5,rep,name=deactivation_hooks,json=deactivationHooks" json:"deactivation_hooks,omitempty"`
	// Individual rules for configuring usage on selected methods.
	Rules []*UsageRule `protobuf:"bytes,6,rep,name=rules" json:"rules,omitempty"`
}

func (m *Usage) Reset()                    { *m = Usage{} }
func (m *Usage) String() string            { return proto.CompactTextString(m) }
func (*Usage) ProtoMessage()               {}
func (*Usage) Descriptor() ([]byte, []int) { return fileDescriptor14, []int{0} }

func (m *Usage) GetRules() []*UsageRule {
	if m != nil {
		return m.Rules
	}
	return nil
}

// Usage configuration rules for the service.
//
// NOTE: Under development.
//
//
// Use this rule to configure unregistered calls for the service. Unregistered
// calls are calls that do not contain consumer project identity.
// (Example: calls that do not contain an API key).
// By default, API methods do not allow unregistered calls, and each method call
// must be identified by a consumer project identity. Use this rule to
// allow/disallow unregistered calls.
//
// Example of an API that wants to allow unregistered calls for entire service.
//
//     usage:
//       rules:
//       - selector: "*"
//         allow_unregistered_calls: true
//
// Example of a method that wants to allow unregistered calls.
//
//     usage:
//       rules:
//       - selector: "google.example.library.v1.LibraryService.CreateBook"
//         allow_unregistered_calls: true
type UsageRule struct {
	// Selects the methods to which this rule applies. Use '*' to indicate all
	// methods in all APIs.
	//
	// Refer to [selector][google.api.DocumentationRule.selector] for syntax details.
	Selector string `protobuf:"bytes,1,opt,name=selector" json:"selector,omitempty"`
	// True, if the method allows unregistered calls; false otherwise.
	AllowUnregisteredCalls bool `protobuf:"varint,2,opt,name=allow_unregistered_calls,json=allowUnregisteredCalls" json:"allow_unregistered_calls,omitempty"`
}

func (m *UsageRule) Reset()                    { *m = UsageRule{} }
func (m *UsageRule) String() string            { return proto.CompactTextString(m) }
func (*UsageRule) ProtoMessage()               {}
func (*UsageRule) Descriptor() ([]byte, []int) { return fileDescriptor14, []int{1} }

func init() {
	proto.RegisterType((*Usage)(nil), "google.api.Usage")
	proto.RegisterType((*UsageRule)(nil), "google.api.UsageRule")
	proto.RegisterEnum("google.api.Usage_ServiceAccess", Usage_ServiceAccess_name, Usage_ServiceAccess_value)
}

func init() {
	proto.RegisterFile("google.golang.org/genproto/googleapis/api/serviceconfig/usage.proto", fileDescriptor14)
}

var fileDescriptor14 = []byte{
	// 372 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x09, 0x6e, 0x88, 0x02, 0xff, 0x64, 0x92, 0x41, 0x8f, 0xd3, 0x30,
	0x10, 0x46, 0x49, 0x43, 0xab, 0xed, 0xc0, 0x86, 0x62, 0x04, 0x8a, 0x38, 0x40, 0x94, 0x53, 0x10,
	0x22, 0x91, 0x96, 0x0b, 0x57, 0x1a, 0x16, 0x58, 0x09, 0xa9, 0x95, 0x77, 0x7b, 0x8e, 0x8c, 0x33,
	0x18, 0x0b, 0xd7, 0x0e, 0x76, 0x52, 0x7e, 0x3c, 0x17, 0x14, 0x37, 0xb4, 0xe9, 0xf6, 0xe8, 0xef,
	0xbd, 0x99, 0xd1, 0x58, 0x03, 0xa5, 0x30, 0x46, 0x28, 0xcc, 0x85, 0x51, 0x4c, 0x8b, 0xdc, 0x58,
	0x51, 0x08, 0xd4, 0x8d, 0x35, 0xad, 0x29, 0xf6, 0x88, 0x35, 0xd2, 0x15, 0xac, 0x91, 0x85, 0x43,
	0xbb, 0x93, 0x1c, 0xb9, 0xd1, 0x3f, 0xa4, 0x28, 0x3a, 0xc7, 0x04, 0xe6, 0x5e, 0x24, 0x30, 0x34,
	0x61, 0x8d, 0x4c, 0xff, 0x4e, 0x60, 0xba, 0xe9, 0x19, 0xf9, 0x0c, 0xd1, 0x50, 0x52, 0x31, 0xce,
	0xd1, 0xb9, 0xf8, 0x61, 0x12, 0x64, 0xd1, 0xd5, 0xeb, 0xfc, 0xa8, 0xe7, 0x5e, 0xcd, 0x6f, 0xf7,
	0xde, 0x47, 0xaf, 0xd1, 0x4b, 0x37, 0x7e, 0x92, 0x14, 0x1e, 0x5b, 0xfc, 0xdd, 0x49, 0x8b, 0x5b,
	0xd4, 0xad, 0x8b, 0x83, 0x24, 0xcc, 0xe6, 0xf4, 0x24, 0x23, 0x39, 0x3c, 0xab, 0xb1, 0x41, 0x5d,
	0xbb, 0xca, 0xe8, 0x6a, 0xa8, 0x77, 0xf1, 0xc4, 0xab, 0x4f, 0x07, 0xb4, 0xd2, 0xc3, 0x1c, 0x47,
	0xde, 0xc0, 0x82, 0xf1, 0x56, 0xee, 0x58, 0x2b, 0x8d, 0xae, 0x7e, 0x1a, 0xf3, 0xcb, 0xc5, 0xa1,
	0x97, 0x9f, 0x1c, 0xf3, 0xaf, 0x7d, 0x4c, 0xde, 0x01, 0xa9, 0xf1, 0x4c, 0x9e, 0xfe, 0xef, 0x7c,
	0x5f, 0x7f, 0x0b, 0x53, 0xdb, 0x29, 0x74, 0xf1, 0x2c, 0x09, 0xb3, 0x47, 0x57, 0xcf, 0xcf, 0x96,
	0xa5, 0x9d, 0x42, 0xba, 0x77, 0xd2, 0x15, 0x5c, 0x9e, 0xac, 0x4e, 0x22, 0x00, 0x7a, 0x7d, 0x7b,
	0x47, 0x6f, 0xca, 0xbb, 0xeb, 0x4f, 0x8b, 0x07, 0x04, 0x60, 0xb6, 0xde, 0x2c, 0xbf, 0xdd, 0x94,
	0x8b, 0x80, 0x10, 0x88, 0x56, 0xf4, 0x4b, 0x35, 0xe2, 0x93, 0xde, 0xef, 0xb3, 0xc1, 0x09, 0x53,
	0x06, 0xf3, 0xc3, 0x10, 0xf2, 0x12, 0x2e, 0x1c, 0x2a, 0xe4, 0xad, 0xb1, 0x71, 0x90, 0x04, 0xd9,
	0x9c, 0x1e, 0xde, 0xe4, 0x03, 0xc4, 0x4c, 0x29, 0xf3, 0xa7, 0xea, 0xb4, 0x45, 0x21, 0x5d, 0x8b,
	0x16, 0xeb, 0x8a, 0x33, 0xa5, 0xfa, 0x5f, 0x0b, 0xb2, 0x0b, 0xfa, 0xc2, 0xf3, 0xcd, 0x08, 0x97,
	0x3d, 0x5d, 0xbe, 0x82, 0x88, 0x9b, 0xed, 0x68, 0xad, 0x25, 0xf8, 0x91, 0xeb, 0xfe, 0x14, 0xd6,
	0xc1, 0xf7, 0x99, 0xbf, 0x89, 0xf7, 0xff, 0x02, 0x00, 0x00, 0xff, 0xff, 0x0c, 0x19, 0x60, 0x91,
	0x5a, 0x02, 0x00, 0x00,
}
